#!/usr/bin/python

from Numeric import *
import Gnuplot, Gnuplot.funcutils,random,time,os

import cgi
import cgitb; cgitb.enable()


#TODO
# graf z funkce
# vyber velikosti bodu0

#print "Content-Type: text/plain\n"
print "Content-Type: image/png\n"

#http://www.duke.edu/~hpgavin/gnuplot.html
def save_uploaded_file (form,form_field,filename,upload_dir="/tmp/"):
    """This saves a file uploaded by an HTML form.
       The form_field is the name of the file input field from the form.
       For example, the following form_field would be "file_1":
           <input name="file_1" type="file">
       The upload_dir is the directory where the file will be written.
       If no file was uploaded or if the field does not exist then
       this does nothing.
    """
    #form = cgi.FieldStorage()
#    print "log 1"
    if not form.has_key(form_field): return
#    print "log 2"
    fileitem = form[form_field]
#    print "log 3"
    if not fileitem.file: return
#    print os.path.join(upload_dir, filename)
    fout = file (os.path.join(upload_dir, filename), 'wb')
    while 1:
        chunk = fileitem.file.read()
        if not chunk: break
        fout.write (chunk)
    fout.close()
    

random_name=""
for i in range(15):
  if i%2==0:
    random_name+=chr(random.randint(97,122))
  else:
    random_name+=chr(random.randint(65,90))
random_name+='_'+str(random.randint(0,100))

form=cgi.FieldStorage()

#print form,"\n"

#print "x-min",form['x_min'].value,'\n\n'

data_type=str(form['data_in'].value)
title=str(form['title'].value)
label_x=str(form['tit_x'].value)
label_y=str(form['tit_y'].value)
data_style=str(form['line_type'].value) # lines, points, linespoints, impulses, dots, steps, errorbars
range_x=(int(form['x_min'].value),int(form['x_max'].value))
range_y=(int(form['y_min'].value),int(form['y_max'].value))
tics_x=str(form['x_min'].value)+" , "+str(form['tics_x'].value)
tics_y=str(form['y_min'].value)+" , "+str(form['tics_y'].value)
line_style="set style line 1 lt -1 lw 1 pt "+str(form['point_type'].value)+" ps 1"
zero_x=str(form['zero_axe_x'].value)
zero_y=str(form['zero_axe_y'].value)
grid=str(form['grid'].value)
fce=None
dimension=None

if data_type=="input":
  fout=open("/tmp/"+random_name+".dat","w")
  for i in range(int(form['value_cnt'].value)):
    j=i+1
    x=""
    y=""
    try:
      x=form['x_'+str(j)].value
      y=form['y_'+str(j)].value
    except:
      x=""
      y=""
    if len(x)<1: x="0"
    if len(y)<1: y="0"
    fout.write(x+' '+y+'\n')
  fout.close() 
  
elif data_type=="file":
  save_uploaded_file(form,"data_file",random_name+'.dat')
elif data_type=="funkce":
  fce=str(form['fce'].value)
  dimension=str(form['dimension'].value)
else:
  print "error"

random_name="/tmp/"+random_name

g=Gnuplot.Gnuplot(debug=0)
g('set terminal png')
g(line_style)
g('unset key')
g('set xlabel "'+label_x+'"')
g('set ylabel "'+label_y+'"')
g('set title "'+title+'"')
g('set zeroaxis')
if zero_x=="unset":
  g('unset xzeroaxis')
if zero_y=="unset":
  g('unset yzeroaxis')
g('set grid')
if grid=="no":
  g('unset grid')  
g('set data style '+data_style)
g('set output "/dev/null"')
if data_type!="funkce":
  g('set xtics '+tics_x)
  g('set ytics '+tics_y)
  g.set_range('xrange',range_x)
  g.set_range('yrange',range_y)
if data_type=="funkce":
  if dimension=="3d":
    g('set pm3d scansautomatic flush begin noftriangles nohidden3d implicit corners2color mean')
    g('set surface')
    g.splot(fce)
  else:
    g.plot(fce)
else:
  g.plot('"'+random_name+".dat"+'" ls 1')
g.hardcopy(filename=random_name+".png", terminal='png')

time.sleep(3.0)


#print "ahoj\n"
fname=random_name+".png"
fin=open(fname,'rb')
x=fin.read()
fin.close()
print x
#print str(form),"\n",str(form.keys())

os.remove(random_name+".png")
if data_type!="funkce":
	os.remove(random_name+".dat")
